From 74608d79bf7312d4e80ffa98e554c72196870b18 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 10 2020 16:49:23 +0000
Subject: [PATCH 1328/2232] Add test of indirect return on member function


    cxxbridge/sources/tests/ffi/lib.rs.cc: In member function ‘rust::cxxbridge05::String tests::Shared::r_method_on_shared() const’:
    cxxbridge/sources/tests/ffi/lib.rs.cc:1583:52: error: no match for ‘operator&’ (operand types are ‘const tests::Shared’ and ‘rust::cxxbridge05::String’)
     1583 |   tests$cxxbridge05$Shared$r_method_on_shared(*this&return$.value);
          |                                               ~~~~~^~~~~~~~~~~~~~
          |                                               |             |
          |                                               |             rust::cxxbridge05::String
          |                                               const tests::Shared

---

diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index 96f9b07..7461d66 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -274,7 +274,7 @@ pub mod ffi {
         fn r_return_r2(n: usize) -> Box<R2>;
         fn get(self: &R2) -> usize;
         fn set(self: &mut R2, n: usize) -> usize;
-        fn r_method_on_shared(self: &Shared) -> usize;
+        fn r_method_on_shared(self: &Shared) -> String;
 
         #[cxx_name = "rAliasedFunction"]
         fn r_aliased_function(x: i32) -> String;
@@ -318,8 +318,8 @@ impl R2 {
 }
 
 impl ffi::Shared {
-    fn r_method_on_shared(&self) -> usize {
-        2020
+    fn r_method_on_shared(&self) -> String {
+        "2020".to_owned()
     }
 }
 
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index fd4751e..c3c797a 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -626,7 +626,7 @@ extern "C" const char *cxx_run_test() noexcept {
   ASSERT(r2->get() == 2021);
   ASSERT(r2->set(2020) == 2020);
   ASSERT(r2->get() == 2020);
-  ASSERT(Shared{0}.r_method_on_shared() == 2020);
+  ASSERT(std::string(Shared{0}.r_method_on_shared()) == "2020");
 
   ASSERT(std::string(rAliasedFunction(2020)) == "2020");
 

